'
'     AD9959 DDS SG2 19  2023.06.29    JE1UCI
'------------------------------------------------------------------------------
$regfile = "m328PDEF.DAT"
$crystal = 800000

Config Portb = &B11111111                                   '0=INPUT 1=OUTPUT
        Portb = &B00000000                                  '1=PULL UP
Config Portc = &B00000000                                   '0=INPUT
        Portc = &B11111111                                  '1=PULL UP
Config Portd = &B00111111                                   '0=INPUT 1=OUTPUT
        Portd = &B11000000                                  '1=PULL UP

Config Lcdmode = Port
Config Lcdbus = 4
Config Lcdpin = Pin , Db4 = Portb.2 , Db5 = Portb.3
Config Lcdpin = Pin , Db6 = Portb.4 , Db7 = Portb.5
Config Lcdpin = Pin , E = Portb.1 , Rs = Portb.0
Config Lcd = 16 * 2

Dim Frq As Long
Dim Frq1 As Single
Dim Start_frq As Long
Dim Max_frq As Long
Dim Min_frq As Long
Dim Max_level As Single
Dim Min_level As Single

Dim Tempa As Byte
Dim Tempb As Byte
Dim Tempc As Byte
Dim Tempd As Byte
Dim Temp_data As Byte
Dim Temp_level As Single
Dim Temp_level1 As Single
Dim Temp_level2 As Word
Dim Temp_level3 As Single
Dim Rena_flag As Byte
Dim Renb_flag As Byte
Dim Renc_flag As Byte
Dim Rend_flag As Byte

Dim Osc As Single
Dim Stephz As Single
Dim Datadec As Single
Dim Ddsdata As Long
Dim Ddshex As Long
Dim Frqdata As String * 9
Dim Flaga As Byte
Dim Flagb As Byte
Dim Flagc As Byte
Dim Flagd As Byte
Dim Level_dbu As Single
Dim Level_dbm As Integer
Dim Level1023 As Single
Dim Level_dds As Integer

   Osc = 250000000                                          '0.5{L
   Start_frq = 50000000                                     'dnm̎g
   Max_frq = 150000000                                      'őg
   Min_frq = 100000                                         'ŏg
   Level_dbu = 80                                           'exaʂŋL
   Max_level = 101
   Min_level = 0
'------------------------------------------------------------------------------
Dataset:
   Frq = Start_frq
   Stephz = Osc / 2147483648
   Datadec = Frq
   Datadec = Datadec / Stephz
   Ddsdata = Round(datadec)
   Waitms 500

   Reset Portd.1                                            'UPD=LOW
   Waitms 100
   Reset Portd.2                                            'CS=LOW
   Waitms 100

   Set Portd.0                                              'RST=HIGH
   Waitms 100                                               'RST=LOW
   Reset Portd.0

   Gosub Csr
   Gosub Fr1
   Gosub Cfr

   Gosub Dds_level
   Gosub Dds_frq
   Cls
   Waitms 500
   Locate 1 , 1
   Lcd " AD9959 DDS SG2  "
   Locate 2 , 1
   Lcd "      by JE1UCI "
   Cursor Off
   Wait 20
   Cls
   Waitms 200
   Gosub Dspfrq
   Gosub Dsp_level

'---------------------------
'X^[g̃[^[GR[_̒lݒ肷
   Tempa = Pinc
   Tempa = Tempa And &H30
   Shift Tempa , Right , 4
   Flaga = Tempa

   Tempb = Pinc
   Tempb = Tempb And &H0C
   Shift Tempb , Right , 2
   Flagb = Tempb

   Tempc = Pinc
   Tempc = Tempc And &H03
   Flagc = Tempc

   Tempd = Pind
   Tempd = Tempd And &HC0

'------------------------------------------------------------------------------
Main:

Main_rena:
   Gosub Rena
       Select Case Rena_flag
          Case 1 : Goto Main_dn
          Case 2 : Goto Main_up
          Case Else : Goto Main_renb
               End Select

Main_up:
   Rena_flag = 0
   Frq = Frq + 1000000
      Frq1 = Frq / 1000000
      Frq = Round(frq1)
      Frq = Frq * 1000000
   Gosub Maxchk
   Goto Main_lcd

Main_dn:
   Rena_flag = 0
   Frq = Frq - 1000000
      Frq1 = Frq / 1000000
      Frq = Round(frq1)
      Frq = Frq * 1000000
   Gosub Minchk
   Goto Main_lcd

'---------------------------
Main_renb:
   Gosub Renb
       Select Case Renb_flag
          Case 1 : Goto Main_dn10k
          Case 2 : Goto Main_up10k
          Case Else : Goto Main_renc
               End Select

Main_up10k:
   Renb_flag = 0
   Frq = Frq + 10000
      Frq1 = Frq / 10000
      Frq = Round(frq1)
      Frq = Frq * 10000
   Gosub Maxchk
   Goto Main_lcd

Main_dn10k:
   Renb_flag = 0
   Frq = Frq - 10000
      Frq1 = Frq / 10000
      Frq = Round(frq1)
      Frq = Frq * 10000
   Gosub Minchk
   Goto Main_lcd

'---------------------------
Main_renc:
   Gosub Renc
       Select Case Renc_flag
          Case 1 : Goto Main_dn100
          Case 2 : Goto Main_up100
          Case Else : Goto Main_rend
               End Select

Main_up100:
   Renc_flag = 0
   Frq = Frq + 100
   Gosub Maxchk
   Goto Main_lcd

Main_dn100:
   Renc_flag = 0
   Frq = Frq - 100
   Gosub Minchk
   Goto Main_lcd

'---------------------------
Main_rend:
   Gosub Rend
       Select Case Rend_flag
          Case 1 : Goto Main_lv_up
          Case 2 : Goto Main_lv_dn
          Case Else : Goto Main_lcd
               End Select

Main_lv_up:
   If Tempd <> 2 Then
      Goto Main_lv_lcd
         End If
   Level_dbu = Level_dbu + 1
   Gosub Level_maxchk
   Goto Main_lv_lcd

Main_lv_dn:
   If Tempd <> 1 Then
      Goto Main_lv_lcd
         End If
   Level_dbu = Level_dbu - 1
   Gosub Level_minchk
   Goto Main_lv_lcd

Main_lv_lcd:
   Rend_flag = 0
   Gosub Dsp_level
   Gosub Level_ctl
   Gosub Dds_level
   Goto Main_end

'---------------------------
Main_lcd:
   Gosub Dspfrq

Main_dds:
   Gosub Level_ctl
   Gosub Dds_level
   Datadec = Frq
   Datadec = Datadec / Stephz
   Ddsdata = Round(datadec)
   Gosub Dds_frq

'---------------------------
Main_end:
   Goto Main
   End

'------------------------------------------------------------------------------
'ȉTu[`
'------------------------------------------------------------------------------
Rena:
   Tempa = Pinc
        Tempa = Tempa And &H30
        Shift Tempa , Right , 4
   Select Case Flaga
      Case 0 : Goto Rena_0
      Case 1 : Goto Rena_1
      Case 2 : Goto Rena_2
      Case 3 : Goto Rena_3
      Case Else : Goto Rena_end
         End Select

Rena_0:
   Select Case Tempa
      Case 0 : Goto Rena_end
      Case 1 : Goto Rena_up
      Case 2 : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select

Rena_1:
   Select Case Tempa
      Case 1 : Goto Rena_end
      Case 3 : Goto Rena_up
      Case 0 : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select

Rena_2:
    Select Case Tempa
      Case 2 : Goto Rena_end
      Case 0 : Goto Rena_up
      Case 3 : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select

Rena_3:
   Select Case Tempa
      Case 3 : Goto Rena_end
      Case 2 : Goto Rena_up
      Case 1 : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select

Rena_up:
   Rena_flag = 1
   Goto Rena_end

Rena_dn:
   Rena_flag = 2

Rena_end:
   Flaga = Tempa
   Return

'------------------------------------------------------------------------------
Renb:
   Tempb = Pinc
        Tempb = Tempb And &H0C
        Shift Tempb , Right , 2
   Select Case Flagb
      Case 0 : Goto Renb_0
      Case 1 : Goto Renb_1
      Case 2 : Goto Renb_2
      Case 3 : Goto Renb_3
      Case Else : Goto Renb_end
         End Select

Renb_0:
   Select Case Tempb
      Case 0 : Goto Renb_end
      Case 1 : Goto Renb_up
      Case 2 : Goto Renb_dn
      Case Else : Goto Renb_end
         End Select

Renb_1:
   Select Case Tempb
      Case 1 : Goto Renb_end
      Case 3 : Goto Renb_up
      Case 0 : Goto Renb_dn
      Case Else : Goto Renb_end
         End Select

Renb_2:
    Select Case Tempb
      Case 2 : Goto Renb_end
      Case 0 : Goto Renb_up
      Case 3 : Goto Renb_dn
      Case Else : Goto Renb_end
         End Select

Renb_3:
   Select Case Tempb
      Case 3 : Goto Renb_end
      Case 2 : Goto Renb_up
      Case 1 : Goto Renb_dn
      Case Else : Goto Renb_end
         End Select

Renb_up:
   Renb_flag = 1
   Goto Renb_end

Renb_dn:
   Renb_flag = 2

Renb_end:
   Flagb = Tempb
   Return

'------------------------------------------------------------------------------
Renc:
   Tempc = Pinc
        Tempc = Tempc And &H03
   Select Case Flagc
      Case 0 : Goto Renc_0
      Case 1 : Goto Renc_1
      Case 2 : Goto Renc_2
      Case 3 : Goto Renc_3
      Case Else : Goto Renc_end
         End Select

Renc_0:
   Select Case Tempc
      Case 0 : Goto Renc_end
      Case 1 : Goto Renc_up
      Case 2 : Goto Renc_dn
      Case Else : Goto Renc_end
         End Select

Renc_1:
   Select Case Tempc
      Case 1 : Goto Renc_end
      Case 3 : Goto Renc_up
      Case 0 : Goto Renc_dn
      Case Else : Goto Renc_end
         End Select

Renc_2:
    Select Case Tempc
      Case 2 : Goto Renc_end
      Case 0 : Goto Renc_up
      Case 3 : Goto Renc_dn
      Case Else : Goto Renc_end
         End Select

Renc_3:
   Select Case Tempc
      Case 3 : Goto Renc_end
      Case 2 : Goto Renc_up
      Case 1 : Goto Renc_dn
      Case Else : Goto Renc_end
         End Select

Renc_up:
   Renc_flag = 1
   Goto Renc_end

Renc_dn:
   Renc_flag = 2

Renc_end:
   Flagc = Tempc
   Return

'------------------------------------------------------------------------------
Rend:
   Tempd = Pind
        Tempd = Tempd And &HC0
        Shift Tempd , Right , 6
   Select Case Flagd
      Case 0 : Goto Rend_0
      Case 1 : Goto Rend_1
      Case 2 : Goto Rend_2
      Case 3 : Goto Rend_3
      Case Else : Goto Rend_end
         End Select

Rend_0:
   Select Case Tempd
      Case 0 : Goto Rend_end
      Case 1 : Goto Rend_up
      Case 2 : Goto Rend_dn
      Case Else : Goto Rend_end
         End Select

Rend_1:
   Select Case Tempd
      Case 1 : Goto Rend_end
      Case 3 : Goto Rend_up
      Case 0 : Goto Rend_dn
      Case Else : Goto Rend_end
         End Select

Rend_2:
    Select Case Tempd
      Case 2 : Goto Rend_end
      Case 0 : Goto Rend_up
      Case 3 : Goto Rend_dn
      Case Else : Goto Rend_end
         End Select

Rend_3:
   Select Case Tempd
      Case 3 : Goto Rend_end
      Case 2 : Goto Rend_up
      Case 1 : Goto Rend_dn
      Case Else : Goto Rend_end
         End Select

Rend_up:
   Rend_flag = 1
   Goto Rend_end

Rend_dn:
   Rend_flag = 2

Rend_end:
   Flagd = Tempd
   Return

'------------------------------------------------------------------------------
Dsp_level:
   Locate 2 , 10
   Select Case Level_dbu
      Case Is >= 100 :
         Lcd Level_dbu
      Case Is >= 10 :
         Lcd " " ; Level_dbu
      Case Is >= 0 :
         Lcd "  " ; Level_dbu
      Case Is > -10 :
         Lcd " " ; Level_dbu
      Case Is <= -10 :
         Lcd "" ; Level_dbu
   End Select

Dsp_level_dbm:
   Level_dbm = Level_dbu - 113
   Locate 2 , 1
   Select Case Level_dbm
      Case Is > 10 :
          Lcd "  " ; Level_dbm
      Case Is > 0 :
         Lcd "   " ; Level_dbm
      Case Is = 0 :
         Lcd "   " ; Level_dbm
      Case Is > -10 :
         Lcd "  " ; Level_dbm
      Case Is > -100 :
         Lcd " " ; Level_dbm
      Case Is <= -100 :
         Lcd Level_dbm
   End Select

Dsp_level_end:
   Locate 2 , 5
   Lcd "dBm"
   Locate 2 , 13
   Lcd "dBu"
   Return

'------------------------------------------------------------------------------
Dspfrq:
   Locate 1 , 2
   Frqdata = Str(frq)
   Select Case Frq
      Case Is >= 100000000 : Goto Dspfrq_lcd8               '100MHz
      Case Is >= 10000000 : Goto Dspfrq_lcd7                '10MHz
      Case Is >= 1000000 : Goto Dspfrq_lcd6                 '1MHz
      Case Is >= 100000 : Goto Dspfrq_lcd5                  '100kHz
      Case Is >= 10000 : Goto Dspfrq_lcd4                   '10kHz
      Case Is >= 1000 : Goto Dspfrq_lcd3                    '1kHz
      Case Is >= 100 : Goto Dspfrq_lcd2                     '100Hz
   End Select

Dspfrq_lcd8:
   Lcd " " : Lcd Left(frqdata , 3) : Lcd "." : Lcd Mid(frqdata , 4 , 3) : Lcd "," : Lcd Mid(frqdata , 7 , 1) : Lcd "MHz  "
   Return

Dspfrq_lcd7:
   Lcd "  " : Lcd Left(frqdata , 2) : Lcd "." : Lcd Mid(frqdata , 3 , 3) : Lcd "," : Lcd Mid(frqdata , 6 , 1) : Lcd "MHz  "
   Return

Dspfrq_lcd6:
   Lcd "   " : Lcd Left(frqdata , 1) : Lcd "." : Lcd Mid(frqdata , 2 , 3) : Lcd "," : Lcd Mid(frqdata , 5 , 1) : Lcd "MHz   "
   Return

Dspfrq_lcd5:
   Lcd "     " : Lcd Left(frqdata , 3) : Lcd "." : Lcd Mid(frqdata , 4 , 1) : Lcd "kHz "
   Return

Dspfrq_lcd4:
   Lcd "      " : Lcd Left(frqdata , 2) : Lcd "." : Lcd Mid(frqdata , 3 , 1) : Lcd "kHz "
   Return

Dspfrq_lcd3:
   Lcd "       " : Lcd Left(frqdata , 1) : Lcd "." : Lcd Mid(frqdata , 2 , 1) : Lcd "kHz "
   Return

Dspfrq_lcd2:
   Lcd "         " : Lcd Left(frqdata , 3) : Lcd "Hz"
    Return

'------------------------------------------------------------------------------
Dds_frq:
   Temp_data = &H04                                         'CFTW0
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Ddshex = Hex(ddsdata)
   Shiftout Portd.4 , Portd.3 , Ddsdata , 1
   Set Portd.1                                              'UPD=HIGH
   Waitus 10
   Reset Portd.1                                            'UPD=LOW
   Return

'------------------------------------------------------------------------------
Dds_level:
   Temp_level = Level_dds - 100
   Temp_level = Temp_level / 20
   Temp_level1 = 10
   Temp_level = Power(temp_level1 , Temp_level)
   Temp_level = Temp_level * Level1023


   If Temp_level > 1023 Then
       Set Portd.5
        Temp_level = 1023
         Goto Dds_level_send
           End If
   Reset Portd.5

Dds_level_send:
'  Temp_level = 1023                                         'x1023no@ʏ͏oȂ
   Temp_level2 = Round(temp_level)
   Temp_data = &H06                                         'ACR
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Temp_data = &H00
   Shiftout Portd.4 , Portd.3 , Temp_data , 1

   Temp_data = High(temp_level2)
   Temp_data = Temp_data And &H0F
   Temp_data = Temp_data Or &H10
   Shiftout Portd.4 , Portd.3 , Temp_data , 1

   Temp_data = Low(temp_level2)
   Shiftout Portd.4 , Portd.3 , Temp_data , 1

   Set Portd.1                                              'UPD=HIGH
   Waitus 2
   Reset Portd.1                                            'UPD=LOW

   Gosub Csr                                                'f[^񂾎p̍đM
   Gosub Fr1
   Gosub Level_ctl
   Return



'------------------------------------------------------------------------------
Level_ctl:                                                  'x␳p̎L
   Frq1 = Frq * 0.000001
   Temp_level3 = Frq1 * Frq1
   Temp_level3 = Temp_level3 * Frq1
   Level1023 = Temp_level3 * -0.00000002
   Temp_level3 = Frq1 * Frq1
   Temp_level3 = Temp_level3 * 0.00001
   Level1023 = Level1023 + Temp_level3
   Temp_level3 = Frq1 * 0.0008
   Level1023 = Level1023 + Temp_level3
   Level1023 = Level1023 + 0.7632
   Level1023 = Level1023 * 1023
   Level_dds = Level_dbu
   Select Case Level_dbu
      Case Is >= 61 : Reset Portb.6                         'ATT1 OFF
      Case Is >= 31 : Set Portb.6
                        Reset Portb.7
                        Level_dds = Level_dbu + 29.5        'ATT1 ON
      Case Is < 31 : Set Portb.7
                      Level_dds = Level_dbu + 59            'ATT2 ON
   End Select
 Return

'------------------------------------------------------------------------------
Minchk:
   If Frq < Min_frq Then
     Frq = Min_frq
        End If
   Return

'------------------------------------------------------------------------------
Maxchk:
   If Frq > Max_frq Then
   Frq = Max_frq
     End If
   Return

'------------------------------------------------------------------------------
Level_minchk:
   If Level_dbu < Min_level Then
     Level_dbu = Min_level
        End If
   Goto Level_minchk_end

Level_minchk_end:
   Return

'------------------------------------------------------------------------------
Level_maxchk:
   If Level_dbu > Max_level Then
   Level_dbu = Max_level
     End If
   Goto Level_maxchk_end

Level_maxchk_end:
   Return

'------------------------------------------------------------------------------
Csr:
   Temp_data = &H00                                         'CSR
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Temp_data = &H42
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Set Portd.1                                              'UPD=HIGH
   Waitus 100
   Reset Portd.1                                            'UPD=LOW
   Return

'------------------------------------------------------------------------------
Fr1:
   Temp_data = &H01                                         'FR1
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Temp_data = &HD3                                         'D3=X20  CB=X18
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Temp_data = &H00
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Temp_data = &H20
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Set Portd.1                                              'UPD=HIGH
   Waitus 10
   Reset Portd.1                                            'UPD=LOW
   Return

'------------------------------------------------------------------------------
Cfr:
   Temp_data = &H03                                         'CFR
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Temp_data = &H00
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Temp_data = &H03
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Temp_data = &H00
   Shiftout Portd.4 , Portd.3 , Temp_data , 1
   Set Portd.1                                              'UPD=HIGH
   Waitus 10
   Reset Portd.1
   Return

'------------------------------------------------------------------------------
   End